/* blackhole.h */
/*
   Copyright (C) 2002
        Chris Kennedy, The Groovy Organization.

   The Blackhole is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The Blackhole is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   For a copy of the GNU Library General Public License
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  or go to http://www.gnu.org
*/

/* _BLACKHOLE_H */
#ifndef _BLACKHOLE_H
#define _BLACKHOLE_H 1

#define MAJOR_VERSION 0
#define MINOR_VERSION 9
#define MINOR_REVISION 52

#ifndef MAIL_DIR
#define MAIL_DIR "mail"
#endif

#ifndef BH_SPOOL_DIR
#define BH_SPOOL_DIR "/var/spool/blackhole"
#endif

#ifndef SM_SPOOL_DIR
#define SM_SPOOL_DIR "/var/spool/mail"
#endif

#ifndef SM_LOCAL_SPOOL
int SPOOLDIR = 0;
#define SM_LOCAL_SPOOL ""
#else
int SPOOLDIR = 1;
#endif

#ifndef LOCKFILE
#define LOCKFILE "/usr/bin/lockfile"
#endif

#ifndef QUEUE_CONFIG
#define QUEUE_CONFIG "/etc/blackhole.conf"
#endif

#ifndef BH_CONFIG
#define BH_CONFIG "mail/.blackhole"
#endif

#ifndef ALT_BH_CONFIG
#define ALT_BH_CONFIG ".blackhole"
#endif

#ifndef MCAFEE_DAT_DIR
#define MCAFEE_DAT_DIR "/opt/uvscan"
#endif

#ifndef MCAFEE_UVSCAN
#define MCAFEE_UVSCAN "/opt/uvscan/uvscan"
#endif

#ifndef MYSQL_USER
#define MYSQL_USER "blackhole"
#endif

#ifndef MYSQL_PASS
#define MYSQL_PASS ""
#endif

#ifndef MYSQL_SERVER
#define MYSQL_SERVER "127.0.0.1"
#endif

#ifndef MYSQL_DOMAIN
#define MYSQL_DOMAIN "default"
#endif

#ifndef RAZOR_BIN
#define RAZOR_BIN "/usr/bin/razor"
#endif

#ifndef BOUNCE_MESSAGE
#define BOUNCE_MESSAGE "Sorry, no mailbox here by that name. (#5.1.1)\n"
#endif

/* Mail Directories */
char *maildir = MAIL_DIR;
char *spool_dir = BH_SPOOL_DIR;
char *sendmail_dir = SM_SPOOL_DIR;
char *lockfile = LOCKFILE;
char *spooldir = SM_LOCAL_SPOOL;

/* Config File Locations */
char *default_cfg = QUEUE_CONFIG;
char *config_file = BH_CONFIG;
char *alt_config_file = ALT_BH_CONFIG;

/* Virus Scanner Programs */
char *dat_dir = MCAFEE_DAT_DIR;
char *uvscan = MCAFEE_UVSCAN;

/* Razor Script */
char *razor_bin = RAZOR_BIN;

/* MySQL Settings */
char *mysql_user = MYSQL_USER;
char *mysql_pass = MYSQL_PASS;
char *mysql_host = MYSQL_SERVER;
char *mysql_domain = MYSQL_DOMAIN;

/* Bounce Message */
char *bounce_msg = BOUNCE_MSG;

/* Option Variables */
FILE *tmp_msg = NULL;
int DEBUG = 0;
int level = 0;

#ifndef QMAIL_QUEUE
#define QMAIL_QUEUE 0
#endif

#ifndef SENDMAIL
#define SENDMAIL 0
#endif

#ifndef MYSQL_CONFIG
#define MYSQL_CONFIG 0
#endif

#ifndef ALLINONE
#define ALLINONE 0
#endif

#ifndef STORE_EMAIL
#define STORE_EMAIL 1
#endif

#ifndef VIRUS_SCAN
#define VIRUS_SCAN 0
#endif

#ifndef VIRUS_ALERT
#define VIRUS_ALERT 0
#endif

#ifndef DISINFECT
#define DISINFECT 0
#endif

#ifndef SPAM_SCAN
#define SPAM_SCAN 1
#endif

#ifndef BOUNCE_MSG
#define BOUNCE_MSG 0
#endif

#ifndef CHECK_SENDER
#define CHECK_SENDER 0
#endif

#ifndef WHITE_LIST
#define WHITE_LIST 0
#endif

#ifndef EXPIRE_TIME
#define EXPIRE_TIME 0
#endif

#ifndef CHECK_REVERSE
#define CHECK_REVERSE 0
#endif

#ifndef PRIORITY
#define PRIORITY 0
#endif

#ifndef CUSTOM_BODY_THRESHHOLD
#define CUSTOM_BODY_THRESHHOLD 1
#endif

#ifndef SPAM_BODY_THRESHHOLD
#define SPAM_BODY_THRESHHOLD 5
#endif

#ifndef PORN_BODY_THRESHHOLD
#define PORN_BODY_THRESHHOLD 3
#endif

#ifndef RACIST_BODY_THRESHHOLD
#define RACIST_BODY_THRESHHOLD 3
#endif

#ifndef USE_MAILDIR
#define USE_MAILDIR 0
#endif

#ifndef VIRUS_SCANNER
#define VIRUS_SCANNER 1
#endif

#ifndef USE_RAZOR
#define USE_RAZOR 0
#endif

#ifndef USE_LOG
#define USE_LOG 0
#endif

#ifndef LOG_TYPE
#define LOG_TYPE 2
#endif

int qmail_queue = QMAIL_QUEUE;
int sendmail = SENDMAIL;
int setgid_sendmail = SETGID_SENDMAIL;
int mysqlconfig = MYSQL_CONFIG;
int allinone = ALLINONE;
int store_email = STORE_EMAIL;
int virusscan = VIRUS_SCAN;
int virus_alert = VIRUS_ALERT;
int disinfect = DISINFECT;
int spam_scan = SPAM_SCAN;
int bouncemsg = BOUNCE_MSG;
int check_sender = CHECK_SENDER;
int white_list = WHITE_LIST;
int expire_time = EXPIRE_TIME;
int checkreverse = CHECK_REVERSE;
int priority = PRIORITY;
int userazor = USE_RAZOR;

int use_maildir = USE_MAILDIR;
int use_log = USE_LOG;
int BODY_SCAN = 0;
int MY_BODY = 0;
int SPAM_BODY = 0;
int PORN_BODY = 0;
int RACIST_BODY = 0;
int CHAR_128 = 0;

int McAfee = 1;
int SophosSDK = 2;
int virus_checker = VIRUS_SCANNER;
int found_virus = 0;

int max_ascii_score = 1;
unsigned int ascii_score = 0;

/* Code for email return */
int EXIT = 0;
int PERMIT = 1;
int DENY = 2;
int ERROR = 3;

/* Body scores */
float my_score = 0, spam_score = 0, porn_score = 0, racist_score = 0;
float my_thresh = CUSTOM_BODY_THRESHHOLD;
float spam_thresh = SPAM_BODY_THRESHHOLD;
float porn_thresh = PORN_BODY_THRESHHOLD;
float racist_thresh = RACIST_BODY_THRESHHOLD;

#ifndef MAXOPTION
#define MAXOPTION 500
#endif

#ifndef MAX_CONFIG_LINE
#define MAX_CONFIG_LINE 255
#endif

enum log_types
{
  error = 0,
  output,
  syslog,
  mysql
};
enum log_types log_type = LOG_TYPE;

enum sections
{   
  A_NO_MATCH = 0,
  A_MATCH_SUBJECT,
  A_MATCH_EMAIL,
  A_MATCH_RELAY,
  A_MATCH_BLACKHOLE,
  A_MATCH_BODY_SPAM,
  A_MATCH_BODY_PORN,
  A_MATCH_BODY_RACIST,
  A_MATCH_WHITE_LIST,
  A_MATCH_MY_EMAIL,
  A_MATCH_SENDER_DNS,
  A_MATCH_MY_BODY,
  A_MATCH_CHARSET,
  A_MATCH_ASCII_128,
  A_MATCH_REVERSE,
  A_MATCH_RAZOR,
  MY_RELAY,
  GOOD_EMAIL,
  BAD_EMAIL,
  GOOD_RELAY,
  BAD_RELAY,
  CONFLEVEL,
  BAD_SUB,
  RBL_HOSTS,
  BOUNCE_550,
  BOUNCE_MES,
  VIRUS_CHK,
  VIRUS_MSG,
  SPAM_CHK,
  BODY_CHK_S,
  BODY_CHK_P,
  BODY_CHK_R,
  WHITE_LIST_CHK,
  MY_EMAIL,
  DNS_CHK,
  VIRUS_CL,
  ALLONE,
  BODY_CHK,
  MY_BODY_CHK,
  CHARSETS,
  MAX_ASCII_128,
  EXPIRE,
  REVERSE,
  RAZOR
};  
int count = 0;

enum spam_matches
{
  NO_MATCH = 0,
  MATCH_SUBJECT,
  MATCH_EMAIL,
  MATCH_RELAY,
  MATCH_BLACKHOLE,
  MATCH_BODY_SPAM,
  MATCH_BODY_PORN,
  MATCH_BODY_RACIST,
  MATCH_WHITE_LIST,
  MATCH_MY_EMAIL,
  MATCH_SENDER_DNS,
  MATCH_MY_BODY,
  MATCH_CHARSET,
  MATCH_ASCII_128,
  MATCH_REVERSE,
  MATCH_RAZOR
};
enum spam_matches match = 0;

struct bh_actions
{
  int active;
  int one_box;
  int delete;
  int bounce;
  char *bounce_msg;
  float score;
  int passthru;
} bh_action[] =
{
  {                             /* NO_MATCH */
  0, 0, 0, 0, NULL, 0.0, 0}
  , {                           /* MATCH_SUBJECT */
  0, 0, 0, 0, NULL, 0.0, 0}
  , {                           /* MATCH_EMAIL */
  0, 0, 0, 0, NULL, 0.0, 0}
  , {                           /* MATCH_RELAY */
  0, 0, 0, 0, NULL, 0.0, 0}
  , {                           /* MATCH_BLACKHOLE */
  0, 0, 0, 0, NULL, 0.0, 0}
  , {                           /* MATCH_BODY_SPAM */
  0, 0, 0, 0, NULL, 0.0, 0}
  , {                           /* MATCH_BODY_PORN */
  0, 0, 0, 0, NULL, 0.0, 0}
  , {                           /* MATCH_BODY_RACIST */
  0, 0, 0, 0, NULL, 0.0, 0}
  , {                           /* MATCH_WHITE_LIST */
  0, 0, 0, 0, NULL, 0.0, 0}
  , {                           /* MATCH_MY_EMAIL */
  0, 0, 0, 0, NULL, 0.0, 0}
  , {                           /* MATCH_SENDER_DNS */
  0, 0, 0, 0, NULL, 0.0, 0}
  , {                           /* MATCH_MY_BODY */
  0, 0, 0, 0, NULL, 0.0, 0}
  , {                           /* MATCH_CHARSET */
  0, 0, 0, 0, NULL, 0.0, 0}
  , {                           /* MATCH_ASCII_128 */
  0, 0, 0, 0, NULL, 0.0, 0}
  , {                           /* MATCH_REVERSE */
  0, 0, 0, 0, NULL, 0.0, 0}
  , {                           /* MATCH_RAZOR */
  0, 0, 0, 0, NULL, 0.0, 0}
  , {                           /* */
  0, 0, 0, 0, NULL, 0.0, 0}
};

/* Spam Error Codes */
char *matches[] = {
  "No Match", "Bad Subject", "Bad Email/Domain",
  "Bad Relay Host/Network", "Relay on RBL Lists", "Body Contains Spam",
  "Body Contains Porn", "Body Contains Racism",
  "Not in White List", "Not To My Addresses/Domains",
  "Sender Address contains invalid hostname",
  "Body Contains My Patterns", "Outside allowed charsets",
  "ASCII above 128 found", "Reverse DNS mismatch on Relay",
  "Razor Check reported KNOWN SPAM",
  '\0'
};

/* Virus Error Codes */
char *viruses[] = {
  "Clean",
  "Infected",
  "Cleaned",
  '\0'
};

/* Maximum options per section */
int maxoptions = MAXOPTION;

char *tmp_file = NULL;
char *spam_file = NULL;
char *virus_file = NULL;
char *final_msg = NULL;
char *virus_type = NULL;

char *log_info = NULL;
char *version = NULL;
char *timestamp = NULL;
char *username = NULL;
char *homedir = NULL;
char *hostname = NULL;

/* Option Variables */
char *charsets[MAXOPTION];
char *mybody[MAXOPTION];
char *myrelays[MAXOPTION];
char *myemail[MAXOPTION];
char *goodemail[MAXOPTION];
char *bademail[MAXOPTION];
char *goodrelays[MAXOPTION];
char *badrelays[MAXOPTION];
char *badsubject[MAXOPTION];
char *rblhosts[MAXOPTION] = {
  "relays.osirusoft.com",
  "bl.spamcop.net",
  "relays.ordb.org",
  "orbs.dorkslayers.com",
  "blackholes.intersil.net",
  "spamguard.leadmon.net",
  "dews.qmail.org",
  "blacklist.spambag.org",
  '\0'
};

/* Functions */
void usage_err(int);
int readconfig(int);
int checkmyrelay(char[], char *[]);
int checkmyemail(char *, char *[]);
int check_dns(char *);
int regexip(char[], char[], char[]);
int rbllookup(char[], char *[], int, int);
int rblcheck(int, int, int, int, char *);
int checkgoodemail(char *, char *[]);
int checkbademail(char *, char *[]);
int checkgoodrelay(char[], char *[]);
int checkbadrelay(char[], char *[]);
int checkbadsub(char[], char *[]);
int check_body(char *);
void exit_mail(int, char *, char *);
int time_stamp(char[]);
int mysql_config(void);
int check_charset(char *, char *[]);
int check_reverse(char *, char *);
int ascii_128(char *);
int get_section(char *);
int add_option(int, char *);
int virus_scan(void);
int maildir_put(char *, char *, char *, char *, int);
int send_mail_box(char *, char *, char *, char *, int);
int mbox_lock(char *);
int mbox_unlock(char *);
int logging(char *);
int expire(char *, int);
int razor_check(void);
int get_action(int, char *);

#endif /* _BLACKHOLE_H */
