/* checkascii128.c */
/*
   Copyright (C) 2002
        Chris Kennedy, The Groovy Organization.

   The Blackhole is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The Blackhole is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   For a copy of the GNU Library General Public License
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  or go to http://www.gnu.org
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern int DEBUG;
extern int ascii_score;
extern int max_ascii_score;
extern char *log_info;

int ascii_128(char *line)
{
  unsigned char *msg = line;

  for(; (*msg) && (ascii_score < max_ascii_score); msg++)
    if(*msg >= 128)
      ascii_score++;

  /* Matched our threshhold */
  if(ascii_score >= max_ascii_score) {
    if(DEBUG)
      fprintf(stderr, "Max ascii characters above 128 found\n\t%s\n", line);

    log_info = malloc(sizeof(int) + 24 + 1);
    if(log_info == NULL)
      return 1;

    snprintf(log_info, (sizeof(int) + 24 + 1),
             "ASCII ABOVE 128 Match(%d)", ascii_score);

    return 1;
  }
  return 0;
}
