/* checkbadsub.c */
/*
   Copyright (C) 2002
        Chris Kennedy, The Groovy Organization.

   The Blackhole is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The Blackhole is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   For a copy of the GNU Library General Public License
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  or go to http://www.gnu.org
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern int DEBUG;
extern char *log_info;

int checkbadsub(char line[255], char *badsubject[])
{
  int i, j, x;
  char *buffer;
  int nomatch = 0;

  buffer = (char *) malloc((strlen(line) * sizeof(char)) + 1);
  if(buffer == NULL)
    return (0);

  for(i = 9, j = 0; line[i] != '\0' && line[i] != '\n'; i++, j++)
    buffer[j] = line[i];
  buffer[j] = '\0';

  for(i = 0; badsubject[i] != NULL; i++) {
    /* ^string$ */
    if(badsubject[i][0] == '^'
       && (badsubject[i][strlen(badsubject[i]) - 1] == '$')) {

      if(strlen(badsubject[i]) != (strlen(buffer) + 2))
        continue;

      for(j = 0, x = 1; badsubject[i][x + 1] != '\0'; j++, x++)
        if(badsubject[i][x] != buffer[j])
          continue;

      if(DEBUG)
        fprintf(stderr, "  Match:  +(%s) ^%s$\n", badsubject[i], buffer);

      log_info = malloc(sizeof(int) + strlen(badsubject[i]) +
                        strlen(buffer) + 28 + 1);
      if(log_info == NULL)
        return (1);

      snprintf(log_info,
               (sizeof(int) + strlen(badsubject[i]) + strlen(buffer) + 28 + 1),
               "BAD SUBJECT(+%d) Match(%s) ^(%s)$", i, badsubject[i], buffer);

      free(buffer);
      return (1);
      /* ^string */
    } else if(badsubject[i][0] == '^') {
      for(j = 0, x = 1; badsubject[i][x] != '\0'; j++, x++) {
        if(buffer[j] == '\0') {
          nomatch = 1;
          break;
        }
        if(badsubject[i][x] != buffer[j]) {
          nomatch = 1;
          break;
        }
      }

      if(!nomatch) {
        if(DEBUG)
          fprintf(stderr, "  Match:  +(%s) ^%s\n", badsubject[i], buffer);

        log_info = malloc(sizeof(int) + strlen(badsubject[i]) +
                          strlen(buffer) + 27 + 1);
        if(log_info == NULL)
          return (1);

        snprintf(log_info,
                 (sizeof(int) + strlen(badsubject[i]) + strlen(buffer) + 27 +
                  1), "BAD SUBJECT(+%d) Match(%s) ^(%s)", i, badsubject[i],
                 buffer);

        free(buffer);
        return (1);
      } else {
        nomatch = 0;
        continue;
      }
      /* string$ */
    } else if(badsubject[i][strlen(badsubject[i]) - 1] == '$') {
      for(j = 0, x = 0; badsubject[i][x + 1] != '\0'; j++) {
        if(buffer[j] == '\0') {
          nomatch = 1;
          break;
        }
        if(badsubject[i][x] == buffer[j]) {
          for(; badsubject[i][x + 1] != '\0'; x++, j++) {
            if(buffer[j] == '\0') {
              nomatch = 1;
              break;
            }
            if(badsubject[i][x] != buffer[j]) {
              nomatch = 1;
              break;
            }
          }
        }
      }

      if(!nomatch) {
        if(DEBUG)
          fprintf(stderr, "  Match:  +(%s) %s$\n", badsubject[i], buffer);

        log_info = malloc(sizeof(int) + strlen(badsubject[i]) +
                          strlen(buffer) + 27 + 1);
        if(log_info == NULL)
          return (1);

        snprintf(log_info,
                 (sizeof(int) + strlen(badsubject[i]) + strlen(buffer) + 27 +
                  1), "BAD SUBJECT(+%d) Match(%s) (%s)$", i, badsubject[i],
                 buffer);

        free(buffer);
        return (1);
      } else {
        nomatch = 0;
        continue;
      }
      /* string */
    } else {
      if(strstr(buffer, badsubject[i])) {
        if(DEBUG)
          fprintf(stderr, "  Match:  +(%s) %s\n", badsubject[i], buffer);

        log_info = malloc(sizeof(int) + strlen(badsubject[i]) +
                          strlen(buffer) + 26 + 1);
        if(log_info == NULL)
          return (1);

        snprintf(log_info,
                 (sizeof(int) + strlen(badsubject[i]) + strlen(buffer) + 26 +
                  1), "BAD SUBJECT(+%d) Match(%s) (%s)", i, badsubject[i],
                 buffer);

        free(buffer);
        return (1);
      }
    }
  }
  if(buffer != NULL)
    free(buffer);
  return (0);
}
